"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findOrCreateContainerLayer = exports.getPageFromRange = exports.getPageFromElement = exports.getWindow = exports.getDocument = void 0;
var getDocument = function (elm) { return (elm || {}).ownerDocument || document; };
exports.getDocument = getDocument;
var getWindow = function (elm) { return (exports.getDocument(elm) || {}).defaultView || window; };
exports.getWindow = getWindow;
var getPageFromElement = function (target) {
    var node = target.closest(".react-pdf__Page");
    if (!node)
        return null;
    var number = Number(node.dataset.pageNumber);
    return { node: node, number: number };
};
exports.getPageFromElement = getPageFromElement;
var getPageFromRange = function (range) {
    var parentElement = range.startContainer.parentElement;
    if (!parentElement)
        return;
    return exports.getPageFromElement(parentElement);
};
exports.getPageFromRange = getPageFromRange;
var findOrCreateContainerLayer = function (container, className) {
    var doc = exports.getDocument(container);
    var layer = container.querySelector("." + className);
    if (!layer) {
        layer = doc.createElement("div");
        layer.className = className;
        container.appendChild(layer);
    }
    return layer;
};
exports.findOrCreateContainerLayer = findOrCreateContainerLayer;
